
$regfile = "attiny13.dat"
$crystal = 1200000

Dim Hystereza As Eram Byte                                  'Hystereza je definovana ako pasmo necitlivosti na zmenu
                                                              'vstupneho napatia a zadava sa v 1/10V
Dim Konstanta As Eram Word                                  'definuje konstantu pre AD prevod

'------------------------------------------------------------------------------
'konstanta prevodu zohladnuje, akemu vstupnemu napatiu bude zodpovedat
'cislo N = 1023 v registri.
'Napr. pre indikator napatia palubnej siete je konstanta 66,41,
'co zodpoveda, ze pri napati palubnej siete 12.0V je N=U*konstanta =120*6641=796920
'ako je vidiet, hodnoty sa zadavaju v 1/10 V, teda 12V = 120. Konstanta je zadana
'v 1/100. N je otom 796, nakolko sa vysledok prevodu nasobi 1000
'------------------------------------------------------------------------------

Dim U(5) As Eram Byte                                       'pole hranicnych hodnot (N)
Dim Vstup As Word                                           ' premenna sluzi na nacitanie hodnoty z ADC
Dim Vstup32 As Long                                         'premenna potrebna pre prepocet Vstup * 1000

Dim I As Byte                                               'pomocne premenne
Dim Pom As Byte
Dim Pom1 As Long
Dim Pom2 As Word
Dim Pom3 As Long

Dim Hyst32 As Long                                          'premenna potrebna na prepocet hysterezy

Config Timer0 = Timer , Prescale = 8                        'definuje parametre casovaca 0

Config Portb = Output                                       ' definuje portb ako vystup okrem PB5
Config Pinb.5 = Input                                       'PB5 je analogovy vstup

Config Aci = Off                                            'vypne analog. komparator

Config Adc = Single , Prescaler = Auto , Reference = Internal       ' definuje vlastnosti AD prevodnika ako spustany s internou referenciou
Set Didr0.adc0d
Start Adc

Reset Portb

Pom = Hystereza                                             'nacita sa hystereza z EEPROM
Pom2 = Konstanta                                            'aprepocita sa Hystereza * Konstanta
Hyst32 = Pom * Pom2
'cela procedura merania sa vykonava v nekonecnej slucke
Do                                                          'nacita sa napatia
Vstup = Getadc(0)                                           'prepocita sa hodnota vstupneho napatia * 1000
Vstup32 = Vstup * 1000

For I = 0 To 4                                              ' v cykle sa porovnava hodnota vstupneho napatia s prepocitanymi hranicnymi hodnotami
   Pom = U(i + 1)
   Pom1 = Pom
   Pom2 = Konstanta
   Pom1 = Pom1 * Pom2
   Pom3 = Pom1 - Hyst32
   Pom1 = Pom1 + Hyst32
   Select Case Vstup32                                      'ak sa prepocitana hodnota vstupneho napatia nachadza v rozpati
                                                             'hranicna_hodnota+/- hystereza, tak sa prislusny vystup portb.i nastavi do H
         Case Pom3 To Pom1 : Set Portb.i                    'v opacnom pripade sa cely port vynuluje
         Case Else : Portb = 0                              'tymto sposobom sa dosiahne efekt bodoveho riadenia LED
   End Select
Next I
Loop


$eeprom                                                     'tieto data sa po prelozeni ulozia do suboru batest_dot.eep. Mozu sa naprogramovat
Data 10 , &HF1 , &H19 , 108 , 120 , 130 , 140 , 150         'priamo do EEPROM procesora
'hystereza,konstanta_spodny,konstanta_horny,5xhranicna hodnota v 1/10V
End