$regfile = "attiny13.dat"
$crystal = 4800000

' pri programovani je potrebne nastavit FUSE bity procesora tak, aby bola frekvencia
' interneho oscilatora 4,8MHz a preddelicka 8 vypnuta
' pri takejto frekvencii oscilatora a pri nastaveniach timer0 ako je uvedene nizsie je frekvencia pwm
' fpwm = 4800000/256 = 18750Hz, co je dost vysoko (nepocut bzucat motorcek). Ak je potrebne tuto frekvenciu
' zvysit, je potrebne zadat $crystal = 9600000 a pri programovani nastavit frekvenciu RC oscilatora na 9,6 MHz
' potom bude fpwm dvojnasobna   37,5kHz
' nabeh oscilatora nie je kriticky, pouzivam najdlhsi cas, pripadne BROWN-OUT detektor

Disable Interrupts
'------------------DEKLARACIA PREMENNYCH---------------------------------------
Dim Pwm_e As Eram Byte
Dim Pwm_ram As Byte
Dim Vystup As Bit
Dim Pwm_old As Byte
Dim I As Byte
Dim Short As Bit
Dim Long_ As Bit

'-----------------DEKLARACIA KONSTANT-------------------------------------------
Const N1 = 20
Const N2 = 200

'----------------NASTAVENIE PERIFERII(ADC,PORTB,WATCHDOG)-----------------------
' nastavuje referenciu pre Urf = 1.1V
' nastavuje delic frekvencie na ADC na 8 => cca 150kHz taktovanie

Config Pinb.5 = Input
Config Pinb.3 = Input
Config Pinb.4 = Output
Config Pinb.0 = Output
Config Pinb.1 = Output
Config Pinb.2 = Output
Config Adc = Single , Prescaler = 64 , Reference = Internal

'takto sa budu za behu nastavovat parametre timer0
'Tccr0a = &HA3                                              ' nastavuje timer0 pre fastpwm, compareA aj compareB clear up
                                                            ' takto bude moc byt vyuzity aj kanal A aj kanal B.
                                                            ' kanal A je vyhradeny pre zataz, kanal B pre indikacnu LED

'-------------------------------------------------------------------------------
'---------------Nastavenie aliasov - symbolickych mien vstupov a vystupov

Vstup Alias Pinb.3
Led Alias Portb.4                                           'umoznuje pripojit na PB4 dalsiu LED ako indikator
Select_ Alias Pinb.5
'-----------------ZACIATOK HLAVNEHO PROGRAMU------------------------------------
Start_pgm:
Portb.0 = 0                                                 ' inicializacia na zaciatku, vystupy su drzane v log0
Portb.1 = 0
Waitms 100                                                  'caka na nabeh systemu

Init:
Pwm_ram = Pwm_e                                             ' nacita hodnoty z EEPROM
Tccr0a = &H03                                               ' tymto nastavenim sa odpoja oba vystupy OC0A aj OC0B (PB0, PB1) od  PWM
                                                            ' zvoli sa mod fastpwm
Pwm_old = Pwm_e
'Start Timer0
Tccr0b = &H01                                               ' spusti timer0 bez preddelicky
Vystup = 0
Do

    If Vstup = 0 Then
                        Gosub Zisti_dlzku
                        If Short = 1 Then                   ' tlacidlo bolo stlacene iba kratko
                                       Toggle Vystup        'zmeni vystup, ak bol v 0 -> 1 a naopak
                                       If Vystup = 0 Then   'toto sa vykona, ak je vystup neaktivny
                                                            Tccr0a = &H03       'odpoji pwm od vystupov. Kedze vystupy su drzane v log0, tymto sa
                                                                                'de facto vystupy vypnu, toto plati pre kanal A aj pre B
                                                            Reset Led       'zhasne LED na PB4
                                                      Else
                                                         If Select_ = 1 Then       ' select_ vybera, ci ide o mod s plynulym nabehom 0 alebo mod s rozbehovym impulzom 1
                                                                                    ' Mod s plynulym nabehom je dobry pre ziarovka, mod s rozbehovym impulzom pre motory a pod.
                                                            Tccr0a = &HA3       ' pripoji pwm na vystupy
                                                            Pwm0a = 255
                                                            Set Led       'zopne LED na PB4
                                                            Waitms 50       '50 ms je dlzka impulzu, potom sa zacina normalny rezim
                                                            Pwm0a = Pwm_ram       'dalej uz je aktivne pwm pre obidva kanaly
                                                            Pwm0b = Pwm_ram
                                                         Else       ' mod pre plynuly rozbeh
                                                            Set Led
                                                            Pwm0a = 0
                                                            Pwm0b = 0
                                                            Tccr0a = &HA3       ' pripoji pwm kanaly na vystup
                                                            For I = 1 To Pwm_ram
                                                                Pwm0a = I       ' plynulo sa meni hodnota pwm, tym sa docieli postupny nabeh zataze
                                                                Pwm0b = I
                                                                Waitms 50
                                                            Next I
                                                         End If
                                       End If

                        End If
                        If Long_ = 1 Then                   'dlhe stlacenie tlacidla, bude sa plynulo menit vystup
                                       If Vystup = 0 Then Pwm_ram = 0
                                       Vystup = 1
                                       Tccr0a = &HA3        ' pripoji pwm kanaly ku vystupom
                                       Set Led
                                       Do
                                          Incr Pwm_ram
                                          If Pwm_ram = 255 Then       'ak pwm_ram (predstavuje hodnotu PWM) dosiahne vrchol
                                                                        ' tak sa vystupy odpoja od pwm kanalov a natvrdo sa nastavia
                                                                        ' na log1
                                                            Tccr0a = &H03
                                                            Portb.0 = 1
                                                            Portb.1 = 1
                                                           For I = 1 To 6       'zablikaju ledky na PB4 aj na oc0b kanali
                                                           Toggle Portb.1       'blika led na oc0b
                                                           Toggle Led       'blika led na pb4
                                                           Waitms 200
                                                           Next I
                                                           Tccr0a = &HA3       'opat pripoji vystupy na pwm kanaly
                                                           Portb.0 = 0       '"tvrde" urovne vystupov PB0 a PB1 nastavi na log0
                                                           Portb.1 = 0
                                                           Waitms 200       'cakanie 200 ms dava obsluhe dostatocny cas pustit tlacidlo
                                                                              ' v opacnom pripade sa zacne hodnota pwm menit od 0
                                          End If
                                          Pwm0a = Pwm_ram   'hodnota premennej pwm_ram sa prekopiruje do registrov Pwm0a a Pwm0b
                                          Pwm0b = Pwm0a
                                          Waitms 20         'krok narastu PWM je 20ms
                                                               ' pre 8 bitove PWM to ma za dosledok, ze cely cyklus od PWM = 0 po PWM = 255
                                                               ' trva cca 256*20 = 5120ms s oneskorenim pri behu programu je to cca 5,5s
                                                               ' komu sa to vidi vela, nech si to zmeni
                                       Loop Until Vstup = 1 'cyklus sa opakuje, pokial je stlacenen tlacidlo (Vstup = 0)
                                                               'ak sa tlacidlo pusti (Vstup = 1), cyklus zmeny konci
                                       Pwm_e = Pwm_ram
                        End If

       End If
     Waitms 20

Loop

'koniec hlavenho programu
'zacinaju podprogramy

Zisti_dlzku:

Waitms 30
'toto oneskorenie je pre eliminovanie zakmitov tlacidla
If Vstup = 1 Then Return                                    'nahodny zakmit tlacidla neprinasa efekt => return to main prog
I = 0
Short = 0
Long_ = 0
Do
   Waitms 5                                                 'ak stlacenie trva menej ako cca 100*5ms tak ide o kratke stlacenie
   Incr I
   If Vstup = 1 Then
                     'short impulz
                     I = 100
                     Short = 1
   End If
Loop Until I = 100
If Short = 0 Then Long_ = 1                                 'ak nebolo stlacene tlacidlo kratko, tak potom bolo stlacene dlho (long_=1)
Return


End_pgm:                                                    'end program
End
